bases = {'abaloneD' 'australianD' 'carD' 'contrasepD' 'diabetesD' 'germanD' 'heartD' 'letterD' 'nurseryD' 'penD' 'segmentD' 'taeD' 'wineD' 'zooD'};

addpath('..')
for i=1:length(bases)
disp('-------------------------------------------')
disp(['    ' bases{i}])
disp('-------------------------------------------')

eval(bases{i})

% optional - useful with draw_graph
names = cell(1,N);
for i=1:N-1
    names{i} = ['E' num2str(i)];
end%for
names{end} = 'C';

% the following lines are some tummy in order to put the class node as
% first node - perhaps useless
app = [app(end,:); app(1:end-1,:)];
test = [test(end,:); test(1:end-1,:)];
ns = [ns(end) ns(1:end-1)];
names = [names(end) names(1:end-1)];

dag = zeros(N,N);
dag(1,2:N) = ones(1,N-1); % naive Bayes classifier (class node at first)
%dag(N,1:N-1) = ones(1,N-1); % naive Bayes classifier (class node at last)

% you may wish to check the structure
%draw_graph(dag,names,ones(1,N));

discrete_nodes = [1:N];
bnet1 = mk_bnet(dag,ns,discrete_nodes);
for i=1:size(app,1)
    bnet1.CPD{i} = tabular_CPD(bnet1,i);
end%for

% evaluation criteria are computation time, log likelyhood and
% classification result
tic
bnet1 = learn_params(bnet1,app); % parameters initialization - ML naive Bayes classifier will be compared to ELR classifier
t1=toc

% scg: Scaled Conjugate Gradient
tic
bnet2 = learn_params_elr(bnet1,app,1,'batch','scg',true); % main algorithm implemented according to [Gre04] - 'batch' is not used at that moment
t2=toc
% conjgrad: Conjugate Gradient
tic
bnet3 = learn_params_elr(bnet1,app,1,'batch','conjgrad',true,[],10); % to compare the two core algorithms
t3=toc

% evaluation of both classifiers with test data
engine1 = jtree_inf_engine(bnet1);
engine2 = jtree_inf_engine(bnet2);
engine3 = jtree_inf_engine(bnet3);
mlLL = 0;
elrLL_scg = 0;
elrLL_cg = 0;
for i=1:Ntest
    evidence = num2cell(test(:,i));
    [aux_engine,LL1] = enter_evidence(engine1,evidence);
    [aux_engine,LL2] = enter_evidence(engine2,evidence);
    [aux_engine,LL3] = enter_evidence(engine3,evidence);
    mlLL = mlLL + LL1;
    elrLL_scg = elrLL_scg + LL2;
    elrLL_cg = elrLL_cg + LL3;
end%for
mlLL = mlLL / Ntest
elrLL_scg = elrLL_scg / Ntest
elrLL_cg = elrLL_cg / Ntest

ml_ratio = classification_evaluation(bnet1,test,1);
elr_scg_ratio = classification_evaluation(bnet2,test,1);
elr_cg_ratio = classification_evaluation(bnet3,test,1);

% [Gre04] Structural Extension to Logistic Regression: Discriminative
%  Parameter Learning of Belief Net Classifiers, Greiner, R., Zhou, W.,
%  Su, X., Shen, B., 2004

end%for
