% test FAN -- toy example with a real TAN network ...

clear all;
close all;

%add_BNT_to_path;

fprintf('\n=== Structure Learning for Forest Augmented Naive Bayes classifier \n');

% data=load('heart.data');
% data=data';
% 
% ns=max(data');
% class=14;
% 
% dag = learn_struct_fan(data, class, ns);
% dag2=learn_struct_tan(data, class,1, ns,'mutual_info');
% dag3=learn_struct_tan(data, class,1, ns,'bic');
% 
% figure; 
% subplot(1,3,1), draw_graph(dag2); title('FAN : cond. mutual information');
% subplot(1,3,2), draw_graph(dag2); title('TAN : cond. mutual information');
% subplot(1,3,3), draw_graph(dag3); title('TAN : BIC score');


N=5;
dag=zeros(N,N);
ns=1+ceil(3*rand(1,N));
class=3;
notclass=setdiff(1:N,class);
dag(class,notclass)=1;
dag(2,5)=1; dag(4,1)=1;

bnet=mk_bnet(dag,ns,1:N);
for i=1:N,
        bnet.CPD{i}= tabular_CPD(bnet, i','CPT','rnd');
end

Nd=500; 
data=zeros(N,Nd);

for i=1:Nd,
data(:,i)=cell2mat(sample_bnet(bnet));
end

dag2 = learn_struct_fan2(data, class, ns); 
%dag3 = learn_struct_fan(data, class, ns,'mutual_info','mean'); 

figure; 
xxx=[0.2 0.8 0.5 0.2 0.8]; 
yyy=[0.8 0.8 0.5 0.2 0.2];
subplot(1,3,1), draw_graph(dag,num2strcell(1:N), zeros(1,N), xxx,yyy); title('theorique');
subplot(1,3,2), draw_graph(dag2,num2strcell(1:N), zeros(1,N), xxx,yyy); title('TAN (auto)');
%subplot(1,3,3), draw_graph(dag3,num2strcell(1:N), zeros(1,N), xxx,yyy); title('TAN (mean)');

fprintf('Editing distance : %d\n',editing_dist(dag,dag2));
